using System;
using System.Windows.Forms;
using System.Net.Sockets;
using System.Text;

namespace ChatClient
{
    public partial class GUI : Form
    {
        
        /// <summary>
        /// GUI elements autogenerated from designer
        /// </summary>
        private Button button;
        private TextBox logTextBox;
        private TextBox typingTextBox;
        private Label statusLabel;
        private Label descriptionLabel;
        private TextBox messageTextBox;

        /// <summary>
        /// TcpClient object
        /// </summary>
        public System.Net.Sockets.TcpClient Client { get; private set; } = new System.Net.Sockets.TcpClient();
        
        /// <summary>
        /// Constructor, intitalizign the GUI form
        /// </summary>
        public GUI()
        {
            InitializeComponent();
        }
        
        /// <summary>
        /// Callback for form loading
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void LoadGUI(object sender, EventArgs e)
        {
            PrintMessageToLog("Client Started");
            this.Client.Connect("127.0.0.1", 1200);
            statusLabel.Text = "Connected";
        }
        
        /// <summary>
        /// Callback for click event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonClick(object sender, EventArgs e)
        {
            NetworkStream serverStream = this.Client.GetStream();
            byte[] outStream = System.Text.Encoding.ASCII.GetBytes(typingTextBox.Text + "$");
            serverStream.Write(outStream, 0, outStream.Length);
            serverStream.Flush();

            byte[] inStream = new byte[65536];
            serverStream.Read(inStream, 0, this.Client.ReceiveBufferSize);
            string returndata = System.Text.Encoding.ASCII.GetString(inStream);
            PrintMessageToLog(returndata);
            typingTextBox.Text = "";
            typingTextBox.Focus();
        }
        
        /// <summary>
        /// Prints message to log text box.
        /// </summary>
        /// <param name="message"></param>
        public void PrintMessageToLog(string message)
        {
            logTextBox.Text = logTextBox.Text + Environment.NewLine + " $ " + message;
        }

        /// <summary>
        /// Initializing form members
        /// </summary>
        private void InitializeComponent()
        {
            this.button = new System.Windows.Forms.Button();
            this.logTextBox = new System.Windows.Forms.TextBox();
            this.messageTextBox = new System.Windows.Forms.TextBox();
            this.statusLabel = new System.Windows.Forms.Label();
            this.descriptionLabel = new System.Windows.Forms.Label();
            this.SuspendLayout();
            // 
            // button
            // 
            this.button.Location = new System.Drawing.Point(487, 465);
            this.button.Name = "button";
            this.button.Size = new System.Drawing.Size(186, 63);
            this.button.TabIndex = 0;
            this.button.Text = "Send Message";
            this.button.UseVisualStyleBackColor = true;
            this.button.Click += new System.EventHandler(this.ButtonClick);
            // 
            // logTextBox
            // 
            this.logTextBox.Location = new System.Drawing.Point(39, 56);
            this.logTextBox.Multiline = true;
            this.logTextBox.Name = "logTextBox";
            this.logTextBox.Size = new System.Drawing.Size(634, 199);
            this.logTextBox.TabIndex = 1;
            // 
            // messageTextBox
            // 
            this.messageTextBox.Location = new System.Drawing.Point(39, 319);
            this.messageTextBox.Multiline = true;
            this.messageTextBox.Name = "messageTextBox";
            this.messageTextBox.Size = new System.Drawing.Size(634, 120);
            this.messageTextBox.TabIndex = 2;
            // 
            // statusLabel
            // 
            this.statusLabel.AutoSize = true;
            this.statusLabel.Location = new System.Drawing.Point(568, 18);
            this.statusLabel.Name = "statusLabel";
            this.statusLabel.Size = new System.Drawing.Size(105, 25);
            this.statusLabel.TabIndex = 3;
            this.statusLabel.Text = "Empty label";
            // 
            // descriptionLabel
            // 
            this.descriptionLabel.AutoSize = true;
            this.descriptionLabel.Location = new System.Drawing.Point(39, 279);
            this.descriptionLabel.Name = "descriptionLabel";
            this.descriptionLabel.Size = new System.Drawing.Size(208, 25);
            this.descriptionLabel.TabIndex = 4;
            this.descriptionLabel.Text = "Type your message here:";
            // 
            // GUI
            // 
            this.ClientSize = new System.Drawing.Size(700, 553);
            this.Controls.Add(this.descriptionLabel);
            this.Controls.Add(this.statusLabel);
            this.Controls.Add(this.messageTextBox);
            this.Controls.Add(this.logTextBox);
            this.Controls.Add(this.button);
            this.Name = "GUI";
            this.Load += new System.EventHandler(this.LoadGUI);
            this.ResumeLayout(false);
            this.PerformLayout();

        }
    }
}